﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Windows;
using Infragistics.Controls.Charts;
using Infragistics.Windows.Editors;

namespace XamDateTimeEditorClock
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private DispatcherTimer Timer { get; set; }
        public XamMonthCalendar MyCalendar { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            this.Unloaded += new RoutedEventHandler(MainWindow_Unloaded);
        }

        void MainWindow_Unloaded(object sender, RoutedEventArgs e)
        {
            this.Timer = null;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            this.Timer = new DispatcherTimer();
            this.Timer.Tick += OnTimerTick;
            this.Timer.Interval = TimeSpan.FromSeconds(1);
            this.Timer.Start();
        }

        private void OnTimerTick(object sender, EventArgs e)
        {
            DateTime now = DateTime.Now;

            if (MyCalendar != null)
            {
                XamRadialGauge ny = Utilities.GetDescendantFromName(MyCalendar, "ny") as XamRadialGauge;
                TextBlock time = Utilities.GetDescendantFromName(MyCalendar, "time") as TextBlock;
                time.Text = now.ToString("hh:mm:ss:tt 'GMT'z");

                ny.Scales[0].Needles[0].Value = now.Hour + now.Minute / 60.0;
                ny.Scales[1].Needles[0].Value = now.Minute;
                ny.Scales[1].Needles[1].Value = now.Second;
            }            
        }

        private void calendarLoaded(object sender, RoutedEventArgs e)
        {
            MyCalendar = sender as XamMonthCalendar;
        }
    }
}
